;
;      To plot 1D slice for 1D test simulations
;      2006.1.20(the)
;
;  Usage:
;
;  idl> .r dread1
;  idl> .r vonz1D1
;
;
; choice of device
;plot_choice='ps'
plot_choice='x'

iwx=2 & jwy=2

;!p.charsize=1.8
;!p.charthick=2.0
;!p.thick=1.5
!p.charsize=1.2
!p.charthick=1.0
!p.thick=1.0
chsz=2.0
rx=0.6

izon=3
;izon=0 : z=0.0 rs

!x.range=[-1.0,1.0]

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
case plot_choice of
'x' : begin
window,4,xs=600,ys=400,retain=2
end
'ps' : begin
set_plot,'ps'
device,/landscape
device,/color,xoffset=0.5,yoffset=24.5,xsize=24,ysize=14,font_size=8
;device,/inches,xsize=7.0,ysize=4.5,yoffset=2.5,xoffset=0.5,font_size=8.5
;!p.font=0 & device,/times,/italic
end
endcase

iw=iwx*jwy
dx0=1./iwx
dy0=1./jwy

!p.multi=[0,iwx,jwy]
!y.margin=[4.,5.]
!x.margin=[5.,6.]

gam=2.0
vt=v1^2+v2^2+v3^2
lo=1.0/sqrt(1.0-vt)

bt=b1^2+b2^2+b3^2

bt1=(b1^2+b2^2+b3^2)/lo^2+(b1*v1+b2*v2+b3*v3)^2

beta=2.0*pp/bt1

sigmc=bt1/(10^dd+(gam/(gam-1.0))*pp)

;
;(1) density
;
;

;ldmyct,clr_index=clr,white=white,black=black
;loadct,5

!y.range=[0.99,1.01]

plot,xar,dd(*,izon),title='!7q!8',xtitle='x',xstyle=1,ystyle=1,linestyle=0
;,color=0

i=0
	x0=dx0*(i mod iwx)
	y0=dy0*((i-(i mod iwx))/iwx)
;;   xyouts,/normal,x0+dx0*0.15,1.-(y0+dy0*0.20-0.05),'time = '
;   xyouts,/normal,x0+dx0*0.50,1.-(y0+dy0*0.20-0.05), $
;;   xyouts,/normal,x0+dx0*0.50,1.-(y0+dy0*0.20-0.05), $
;;     strmid(strcompress(string(time),/remove_all),0,4)
;
; (2) pressure
;

!y.range=[49.0,51.0]


plot,xar,pp(*,izon),title='p',xtitle='x',xstyle=1,ystyle=1,linestyle=0
;,color=0

;
; (3) Vx
;

!y.range=[-0.01,0.5]

plot,xar,v1(*,izon),title='v!Dx!N',xtitle='x',xstyle=1,ystyle=1,linestyle=0
;,color=0


; (6) By
;

!y.range=[-1.1,1.1]

byex1=fltarr(ixmax,iymax)
byex2=fltarr(ixmax,iymax)

eta=0.01
tmp1=1.0/xx^2
tmp1a=sqrt(eta*tmp1)
for i=0,ixmax/iskix-1 do begin
 for j=0,iymax/iskiy-1 do begin
   if(xx(i,j) ge 0.0) then begin
     byex1(i,j)=errorf(1.0/(2.0*tmp1a(i,j)))
   endif 
   if(xx(i,j) le 0.0) then begin
     byex1(i,j)=-errorf(1.0/(2.0*tmp1a(i,j)))
   endif
  endfor
endfor      

tmp2=10.0/xx^2
tmp2a=sqrt(eta*tmp2)
for i=0,ixmax/iskix-1 do begin
 for j=0,iymax/iskiy-1 do begin
   if(xx(i,j) ge 0.0) then begin
     byex2(i,j)=errorf(1.0/(2.0*tmp2a(i,j)))
   endif 
   if(xx(i,j) le 0.0) then begin
     byex2(i,j)=-errorf(1.0/(2.0*tmp2a(i,j)))
   endif
  endfor
endfor      


plot,xar,-b3(*,izon),title='B!Dy!N',xtitle='x',xstyle=1,ystyle=1,linestyle=0
;oplot,xar,byex1(*,izon),linestyle=1
oplot,xar,byex2(*,izon),linestyle=2
;,color=0

nolm1=0.0
ivol=0.0

for i=3,ixmax/iskix-4 do begin
    temp1=abs(byex2(i,izon)+b3(i,izon))
    nolm1=nolm1+temp1  
    ivol=ivol+1.0
endfor
print,nolm1/ivol

if (plot_choice ne 'x') then begin
;   device,color=0
   device,/close
;   !p.font=-1
;   set_plot,'x'
endif
end


