;
;      To plot 1D slice for 1D test simulations
;      2006.1.20(the)
;
;  Usage:
;
;  idl> .r dread1
;  idl> .r vonz1D1
;
;
; choice of device
;plot_choice='ps'
plot_choice='x'

iwx=2 & jwy=2

;!p.charsize=1.8
;!p.charthick=2.0
;!p.thick=1.5
!p.charsize=1.2
!p.charthick=1.0
!p.thick=1.0
chsz=2.0
rx=0.6

izon=3
;izon=0 : z=0.0 rs

!x.range=[-0.5,0.5]

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
case plot_choice of
'x' : begin
window,4,xs=700,ys=500,retain=2
end
'ps' : begin
set_plot,'ps'
device,/landscape
device,/color,xoffset=0.5,yoffset=24.5,xsize=24,ysize=14,font_size=8
;device,/inches,xsize=7.0,ysize=4.5,yoffset=2.5,xoffset=0.5,font_size=8.5
;!p.font=0 & device,/times,/italic
end
endcase

iw=iwx*jwy
dx0=1./iwx
dy0=1./jwy

!p.multi=[0,iwx,jwy]
!y.margin=[4.,5.]
!x.margin=[5.,6.]

gam=2.0
vt=v1^2+v2^2+v3^2
vtex=vxex^2+vyex^2+vzex^2
lo=1.0/sqrt(1.0-vt)
loex=1.0/sqrt(1.0-vtex)

bt=b1^2+b2^2+b3^2

bxex=fltarr(ixmax1)
ppex=fltarr(ixmax1)
;for i=0,ixmax1-1 do begin
; bxex(i)=0.5
;endfor

bt1=(b1^2+b2^2+b3^2)/lo^2+(b1*v1+b2*v2+b3*v3)^2
btex1=(bxex^2+byex^2+bzex^2)/loex^2+(bxex*vxex+byex*vyex+bzex*vzex)^2

btex=bxex^2+byex^2+bzex^2
ppex=ptotex-(btex1/2.0)

beta=2.0*pp/bt1
;betaex=2.0*ppex/btex1

sigmc=bt1/(10^dd+(gam/(gam-1.0))*pp)
sigex=btex1/(roex+(gam/(gam-1.0))*ppex)

;
;(1) density
;
;

;ldmyct,clr_index=clr,white=white,black=black
;loadct,5

!y.range=[0.1,1.15]

plot,xar,dd(*,izon),title='!7q!8',xtitle='x',xstyle=1,ystyle=1,linestyle=1
;,color=0
oplot,xex,roex(*),linestyle=0
;,color=30

i=0
	x0=dx0*(i mod iwx)
	y0=dy0*((i-(i mod iwx))/iwx)
;;   xyouts,/normal,x0+dx0*0.15,1.-(y0+dy0*0.20-0.05),'time = '
;   xyouts,/normal,x0+dx0*0.50,1.-(y0+dy0*0.20-0.05), $
;;   xyouts,/normal,x0+dx0*0.50,1.-(y0+dy0*0.20-0.05), $
;;     strmid(strcompress(string(time),/remove_all),0,4)
;
; (2) pressure
;

!y.range=[0.0,1.2]


plot,xar,pp(*,izon),title='p',xtitle='x',xstyle=1,ystyle=1,linestyle=1
;,color=0
oplot,xex,ppex(*),linestyle=0
;,color=30

;
; (3) Vx
;

!y.range=[-0.01,0.5]

plot,xar,v1(*,izon),title='v!Dx!N',xtitle='x',xstyle=1,ystyle=1,linestyle=1
;,color=0
oplot,xex,vxex(*),linestyle=0
;,color=30

;
; (4) Vy
;

;!y.range=[-0.11,0.11]

;plot,xar,-v3(*,izon),title='v!Dy!N',xtitle='x',xstyle=1,ystyle=1,linestyle=0
;,color=0
;oplot,xex,vyex(*),linestyle=1
;,color=30

;
; (5) Vz
;

;!y.range=[-0.5,0.5]
;
;plot,xar,v2(*,izon),title='v!Dz!N',xtitle='x',xstyle=1,linestyle=0
;oplot,xex,vzex(*),linestyle=1

; (6) By
;

!y.range=[-1.0,0.6]

plot,xar,-b3(*,izon),title='B!Dy!N',xtitle='x',xstyle=1,ystyle=1,linestyle=1
;,color=0
oplot,xex,byex(*),linestyle=0
;,color=30

;
; (7) Bz
;

;!y.range=[-1.0,1.0]
;


;plot,xar,b2(*,izon),title='B!Dz!N',xtitle='x',xstyle=1,linestyle=0
;oplot,xex,bzex(*),linestyle=1

;
; (8)Lorentz factor
;

;!y.range=[1.0,1.15]


;plot,xar,lo(*,izon),title='Lorentz factor',xtitle='x',xstyle=1,linestyle=0
;,color=0
;oplot,xex,loex(*),linestyle=1
;,color=30

nolm1=0.0
ivol=0.0

;for i=0,ixmax/iskix-1 do begin
;  ichk=0
;  for k=0,ixmax1-1 do begin
;    if(xex(k) ge xar(i) and ichk eq 0) then begin
;      print,i,xar(i),xex(k)
;      ichk=1
;      temp1=abs(roex(k)-dd(i,izon))
;      temp2=abs(roex(k-1)-dd(i,izon))
;      temp3=min(temp1,temp2)
;      nolm1=nolm1+temp3
;    endif
;  endfor
;  
;    ivol=ivol+1.0
;endfor
;print,nolm1/ivol

if (plot_choice ne 'x') then begin
;   device,color=0
   device,/close
;   !p.font=-1
;   set_plot,'x'
endif
end


